using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using IHSTI.MSMQMessaging;
using MSMQCommon;

namespace ProcCallHandler
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox tbParams;
		private System.Windows.Forms.Button btnfetch;
		private System.Windows.Forms.Button btnProcessQueue;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tbParams = new System.Windows.Forms.TextBox();
			this.btnfetch = new System.Windows.Forms.Button();
			this.btnProcessQueue = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// tbParams
			// 
			this.tbParams.Location = new System.Drawing.Point(32, 24);
			this.tbParams.Multiline = true;
			this.tbParams.Name = "tbParams";
			this.tbParams.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.tbParams.Size = new System.Drawing.Size(256, 144);
			this.tbParams.TabIndex = 0;
			this.tbParams.Text = "";
			// 
			// btnfetch
			// 
			this.btnfetch.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnfetch.Location = new System.Drawing.Point(32, 192);
			this.btnfetch.Name = "btnfetch";
			this.btnfetch.Size = new System.Drawing.Size(128, 40);
			this.btnfetch.TabIndex = 1;
			this.btnfetch.Text = "Fetch Single Message";
			this.btnfetch.Click += new System.EventHandler(this.btnfetch_Click);
			// 
			// btnProcessQueue
			// 
			this.btnProcessQueue.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnProcessQueue.Location = new System.Drawing.Point(160, 192);
			this.btnProcessQueue.Name = "btnProcessQueue";
			this.btnProcessQueue.Size = new System.Drawing.Size(128, 40);
			this.btnProcessQueue.TabIndex = 2;
			this.btnProcessQueue.Text = "Process Queue unti Empty";
			this.btnProcessQueue.Click += new System.EventHandler(this.btnProcessQueue_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.BackColor = System.Drawing.SystemColors.Info;
			this.ClientSize = new System.Drawing.Size(304, 312);
			this.Controls.Add(this.btnProcessQueue);
			this.Controls.Add(this.btnfetch);
			this.Controls.Add(this.tbParams);
			this.Name = "Form1";
			this.Text = "Proc Call Handler";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private MSMQCommon.ProcCall procCall;

		private void NoMessage()
		{
			tbParams.Text += "No procedure call waiting" + Environment.NewLine;
		}

		private void ShowParams()
		{
			tbParams.Clear();
			tbParams.Text = "StringCollection Parameters:" + Environment.NewLine;
			for (int i=0; i<procCall.theParamSet.strColl.Count; i++)
				tbParams.Text += procCall.theParamSet.strColl[i] + Environment.NewLine;
			tbParams.Text += "Record Parameters:" + Environment.NewLine;
			tbParams.Text += procCall.theParamSet.record.item1 + Environment.NewLine;
			tbParams.Text += procCall.theParamSet.record.item2.ToString() + Environment.NewLine;
			tbParams.Text += procCall.theParamSet.record.item3 + Environment.NewLine;
		}

		private void ProcCall_1()
		{
			MessageBox.Show("ProcCall_1 called");
			ShowParams();
		}
		private void ProcCall_2()
		{
			MessageBox.Show("ProcCall_2 called");
			ShowParams();
		}
		private void ProcCall_3()
		{
			MessageBox.Show("ProcCall_3 called");
			ShowParams();
		}
		private void btnfetch_Click(object sender, System.EventArgs e)
		{
			procCall = (MSMQCommon.ProcCall) (new MSMQ(Common.queueName,Common.queueLabel) as IMSMQ).ReadMessage(typeof(MSMQCommon.ProcCall));
			if (procCall==null)
				NoMessage();
			else
			{
				switch (procCall.theProcName) 
				{
					case ("ProcCall_1") :
						ProcCall_1();
						break;
					case ("ProcCall_2") :
						ProcCall_2();
						break;
					case ("ProcCall_3") :
						ProcCall_3();
						break;
				}
				
			}
		}

		private void btnProcessQueue_Click(object sender, System.EventArgs e)
		{
			IMSMQ queueReader = (new MSMQ(Common.queueName,Common.queueLabel) as IMSMQ);

			while (!queueReader.IsEmpty())

			{
				procCall = (MSMQCommon.ProcCall) queueReader.ReadMessage(typeof(MSMQCommon.ProcCall));
				if (procCall==null)
				{
					NoMessage();
					break;
				}
				else
				{
					switch (procCall.theProcName) 
					{
						case ("ProcCall_1") :
							ProcCall_1();
							break;
						case ("ProcCall_2") :
							ProcCall_2();
							break;
						case ("ProcCall_3") :
							ProcCall_3();
							break;
					}
				
				}

				System.Threading.Thread.Sleep(1000);
			}
		tbParams.Text += "Done";
		}
	}
}
